Bug 968903 - DataObject without Input/Output icon
DataObject without Input/Output icon
Status: ASSIGNED
Product: JBoss BPMS Platform 6
Classification: JBoss
Component: jBPM Designer (Show other bugs)
6.0.0
Unspecified Unspecified
medium Severity low
: ---
: 6.0.1
Assigned To: Tihomir Surdilovic
Kirill Gaevskii
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-30 05:01 EDT by Toshiya Kobayashi
Modified: 2016-01-08 16:45 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
dataobject_600er2.png (204.54 KB, image/png)
2013-08-30 01:57 EDT, Toshiya Kobayashi
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker JBPM-4019 Major Resolved DataObject without Input/Output icon 2017-01-04 23:23 EST

  None (edit)
Description Toshiya Kobayashi 2013-05-30 05:01:52 EDT
Description of problem:

Platform BZ for https://issues.jboss.org/browse/JBPM-4019


Steps to Reproduce:
1. Write a DataObject and 2 Tasks. 
2. Write incoming association to the DataObject and outgoing association from the DataObject.
3. Save

# screenshots in JBPM-4019 would explain a lot.

Actual results:

DataObject turns into DataInput (= with Input icon inside)

Expected results:

DataObject appearance stays the same.
Comment 1 Kris Verlaenen 2013-05-31 18:42:24 EDT
I believe data associations on data objects are currently not supported.  While I don't think we can add support for this in BPMS 6.0, we should probably look at not allowing these data associations to be drawn in the first place (as they are not supported).
Comment 2 JBoss JIRA Server 2013-06-03 10:28:42 EDT
Tihomir Surdilovic <tsurdilo@redhat.com> made a comment on jira JBPM-4019

I don't understand the issue here. The Data Object stays a Data Object, with just its type set to Input / Output depending how it is used. In case of both input and output as in this example Input is chosen by default. There are no data associations properties in the data object nodes, but the connected tasks in this example get dynamically inserted the property data inputs/outputs and assignments which seem correct to me. Please explain what the issue is here :)

Thanks.
Comment 3 JBoss JIRA Server 2013-06-04 03:42:02 EDT
Toshiya Kobayashi <tkobayas@redhat.com> made a comment on jira JBPM-4019

Hi Tiho,

Well, the customer's concern is just about the appearance. They expect that the DataObject with incoming+outgoing connections should not have the input/output icon inside. It may not be clearly stated in BPMN 2.0 but it sounds reasonable to me. What do you think?
Comment 4 JBoss JIRA Server 2013-06-04 03:42:05 EDT
Toshiya Kobayashi <tkobayas@redhat.com> made a comment on jira JBPM-4019

Hi Tiho,

Well, the customer's concern is just about the appearance. They expect that the DataObject with incoming+outgoing connections should not have the input/output icon inside. It may not be clearly stated in BPMN 2.0 but it sounds reasonable to me. What do you think?
Comment 5 JBoss JIRA Server 2013-06-04 07:49:18 EDT
Tihomir Surdilovic <tsurdilo@redhat.com> made a comment on jira JBPM-4019

I think that is OK. I will remove the embedded image asap.
Comment 6 JBoss JIRA Server 2013-06-04 09:10:37 EDT
Toshiya Kobayashi <tkobayas@redhat.com> made a comment on jira JBPM-4019

Thanks Tiho.

Just in case, I rephrase the expected results.

- If a DataObject has an outgoing connection, it has Input icon inside. (It's already implemented so)
- If a DataObject has an incoming connection, it has Output icon inside. (It's already implemented so)
- If a DataObject has both incoming and outgoing connections, it has no icon inside. (This is the request of this JIRA)
Comment 7 JBoss JIRA Server 2013-06-04 18:57:11 EDT
Tihomir Surdilovic <tsurdilo@redhat.com> updated the status of jira JBPM-4019 to Resolved
Comment 8 JBoss JIRA Server 2013-06-04 18:57:11 EDT
Tihomir Surdilovic <tsurdilo@redhat.com> made a comment on jira JBPM-4019

fix in master
Comment 10 Sona Mala 2013-08-29 08:57:51 EDT
Is this issue valid for ER2? This issue is ON_QA with ER2 but target release is ER3.

State in ER2:
  - Data Object does not contain any icon for all states (Input, Output, Input/Output)
  - this solution does not correspond with comment #6.
Comment 11 Toshiya Kobayashi 2013-08-30 01:57:28 EDT
Created attachment 792034 [details]
dataobject_600er2.png
Comment 12 Toshiya Kobayashi 2013-08-30 02:04:36 EDT
Hi Sona,

You can change the icon by DataObject's property "Input/Output".

I have attached dataobject_600er2.png.

I think it's okay for this BZ.

But hmm, if Tiho intends that it should happens automatically, he may want to fix.

WDYT? Tiho.
Comment 13 Sona Mala 2013-08-30 07:23:49 EDT
Ok. So for ER2:
  - the user can choose an icon which does not reflected actual state.
  - the icon has no effect on direction of association. 
  - BPMN2 source code depends on flow elements on canvas.

This behaviour can lead to inconsistence between BPMN2 source code and visual information.
Comment 14 Tihomir Surdilovic 2013-08-30 09:32:01 EDT
I think would be best to hide the Input/Output property then on Data Objects then? WDYT?

Thanks.
Comment 15 Sona Mala 2013-09-02 03:11:43 EDT
Does Designer change Input/Output icons automatically?

Like:
  - if user append a data object to task than the Input icon is shown
  - if user add/remove an association to/from the data object than its icon depends on direction of all associations:
          - incoming direction - INPUT ICON
          - outgoing direction - OUTPUT ICON
          - both direction - ANY ICON
          - undirected - ANY ICON


Or you remove icons from data object?

In case that Designer does not change icons automatically I suggest to leave Input/Output property in Properties Bar and add validation issue "Input/Output property does not reflected a state of data object."
Comment 16 Toshiya Kobayashi 2013-09-02 03:34:01 EDT
Hi Tiho,

You seemed to comment-out the automatic icon setting logic in this commit.

https://github.com/droolsjbpm/jbpm-designer/commit/65017f4ec16b6774395f2cc6f1488e762571a974

+//        if(outgoingAssociaton != null && incomingAssociation == null) {
+//            properties.put("input_output", "Input");
+//        }
+//
+//        if(outgoingAssociaton == null && incomingAssociation != null) {
+//            properties.put("input_output", "Output");
+//        } 

I'm not sure if it can be a problem for JBPM-4020 (A Data Object associated with a Sequence Flow) but can you just uncomment the lines?

Then hiding the Input/Output property would sound fine.
Comment 17 Tihomir Surdilovic 2013-09-03 09:20:22 EDT
@Toshiya: uncommented those lines and hide the Input/Output property.

Thanks.
Comment 19 Kris Verlaenen 2014-02-10 21:42:47 EST
Re-enabling data object post 6.0.1.GA
https://bugzilla.redhat.com/show_bug.cgi?id=1042524

Note You need to log in before you can comment on or make changes to this bug.